﻿using System.Runtime.Serialization;

namespace System.Lua
{
    /// <summary>
    /// The exception that is thrown when the Lua code could not be parsed during a deserialization.
    /// </summary>
    [Serializable]
    public class CouldNotInterpretException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CouldNotInterpretException"/> class.
        /// </summary>
        public CouldNotInterpretException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="CouldNotInterpretException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public CouldNotInterpretException(string message, Exception innerException)
            : base(message, innerException)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="CouldNotInterpretException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public CouldNotInterpretException(string message) : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="CouldNotInterpretException"/> class.
        /// </summary>
        /// <param name="info">The <see cref="T:System.Runtime.Serialization.SerializationInfo"/> that holds the serialized object data about the exception being thrown.</param>
        /// <param name="context">The <see cref="T:System.Runtime.Serialization.StreamingContext"/> that contains contextual information about the source or destination.</param>
        /// <exception cref="T:System.ArgumentNullException">
        /// The <paramref name="info"/> parameter is null.
        /// </exception>
        /// <exception cref="T:System.Runtime.Serialization.SerializationException">
        /// The class name is null or <see cref="P:System.Exception.HResult"/> is zero (0).
        /// </exception>
        protected CouldNotInterpretException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
    }
}